#this whole idea will not work for untied tasks
import re
from collections import OrderedDict
import sys
import json

'''
The script is prepared to accept as many taskgraphs as generated by the application. Input:
    - n .dot files
    - .prv file contains the execution data measured by Extrae, the .dot file contains the TDG structure and related info gathered by Mercurium
    - .pcf file contains list of Extrae configuration flags, including PAPI event flags, then we know which hardware counters have been collected
'''

if(len(sys.argv)) < 4:
    print("Too few arguments")
    quit()

tdgFiles = []
for i in range(1, len(sys.argv)-2): tdgFiles.append(sys.argv[i])
prvInputFile = sys.argv[len(sys.argv)-2]
pcfInputFile = sys.argv[len(sys.argv)-1]

appName = prvInputFile.split(".prv",1)[0]          
shouldOverwriteInputJsonFile = False

if not(all(map(lambda x: x.endswith(".dot") or x.endswith(".json"), tdgFiles))) or \
   not(prvInputFile.endswith(".prv")) or \
   not(pcfInputFile.endswith(".pcf")):
    print("\n Wrong input files. Expecting, in order: tdg_x.dot||tdg_x.json example.prv example.pcf. Exiting. \n")
    quit()


#in the prv file the lines are events; the current time is captured for every event; 
#the time flows "downwards" meaning that events on the bottom of the file happened after events on the top of the file;
#5th number in each event is the thread id; this means that events must be grouped into events belonging to each thread, so that their timeline can be followed correctly;
#we are interested into events of task execution begin and task execution end, to know when tasks are executing;
#task execution is marked by flag 60000023, while task id itself is marked by flag 60000028; the latter appears only in events of task execution begin;
#for events of task execution end, flag 60000028 is not present, and flag 60000023 has zero value (first next number (to the right) beside the flag),
#this means that we have to track the timeline of each thread to know which task has ended in the given event (the task that started the last), 
#since the task execution end event data itself does not show that
lines = []
with open(prvInputFile) as prvInput:
    lines = prvInput.readlines()
papiEventLines = ""
with open(pcfInputFile) as pcfInput:
    papiEventLines = pcfInput.read()

papiEventsFlagList = re.findall(r'42[0-9]{6}', papiEventLines) #the flag for the hardware event counters is always 42 mln something

#exampe for papi event flags, from the pcf
#EVENT_TYPE 
#7  42000050 PAPI_TOT_INS [Instr completed]
#7  42000059 PAPI_TOT_CYC [Total cycles]
#7  42000000 PAPI_L1_DCM [L1D cache misses]
#7  42000002 PAPI_L2_DCM [L2D cache misses]
#7  42000008 PAPI_L3_TCM [L3 cache misses]
#7  42000055 PAPI_BR_INS [Branches]
#7  42000046 PAPI_BR_MSP [Cond br mspredictd]
#7  42001047 RESOURCE_STALLS [Cycles Allocation is stalled due to Resource Related reason]
#=>
#  papiEventFlags = ['42000050', '42000059', '42000000', '42000002', '42000008', '42000055', '42000046', '42001047']

papiEventFlags = papiEventsFlagList
additionalInfoFlags = ["thread", "execution_begin_time", "execution_end_time"]
capturingEventTimeFlag = '60000023' #task execution flag, positioned just behind the execution time
capturingEventIdFlag = '60000028' #task id flag, which will have the value of the ID in the first following prv field
capturingEventTaskgraphIdFlag = '60000061' #adding flag to be captured alter papi counters capture correctness
captureEventFlags = [capturingEventIdFlag, capturingEventTimeFlag, capturingEventTaskgraphIdFlag] + papiEventFlags
captureEventValues = {} #are the values for the flags in captureEventFlags, but mapped per thread
numOfPapiEvents = len(papiEventFlags)
numOfValuesToCapture = len(captureEventFlags)  #event id, event time, taskgrph id, all papi event counters in the current prv
captureEventIdIndx = 0 #for the ease of reading
captureEventTimeIndx = 1
captureEventTaskgraphIndx = 2 
allCapturesCollection = [] #the final result of the first part of the script (parsing extrae outputs)

def initCountersIfNeeded(captureEventValues, thrId):
    if(thrId not in captureEventValues):
        captureEventValues[thrId] = [0] * numOfValuesToCapture 

def resetCounters(captureEventValues, thrId):
    if(thrId in captureEventValues):
        captureEventValues[thrId] = [0] * numOfValuesToCapture
    else:
        print("Error! Counters should already be initialized for this thread, before reset.")
        quit()

#PAPI counters show the sum of all event counts, since the last event execution,
#which means it is enough to just add them up in the timeframe that we need (like during a capture event)
def incrementCounterValuesForEventInThread(captureEventValues, thrId, entry):
    papiEventIndx = 0 #since the captureEvents have 3 more values than papiEvents, need to add it to the papiEventIndx below
    while papiEventIndx < len(papiEventFlags):
        papiEvent = papiEventFlags[papiEventIndx] #the trick here is that papi event flags (in papiEventFlags list) are ordered exactly in the order we will collect the data for them
        #this means that papiEventIndx will be the same index for the list of flags as for the list of values that belong to these papi event flags
        indx = 0
        while(indx < len(entry)):
            #the value of the papi counter is always located right after the papi event id in the prv entry (prv line):
            if(papiEvent == entry[indx]):
                #and we want to add up all others, because they measure sum of events in a given timeframe (since the last measurement)
                captureEventValues[thrId][3 + papiEventIndx] = captureEventValues[thrId][3 + papiEventIndx] + int(entry[indx+1])
                break; #we need only the first match, cause we are interested only in first papi event val, that is in Next Evt Val
            indx += 1
        papiEventIndx += 1
    #print(captureEventValues[thrId])

def isCaptureEventStart(entry):
    if((capturingEventIdFlag in entry) and (capturingEventTimeFlag in entry)):
        return True
    else:
        return False

def isCaptureEventEnd(entry):
    if( (capturingEventTimeFlag in entry) and not (capturingEventIdFlag in entry) and (entry[entry.index(capturingEventTimeFlag)+1] == '0') ):
        return True
    else:
        return False

#assuming that this is correctly recognized capture start event (in the current case: capture event is task execution event 60000023, but this can be changed if needed)
def startEventCapture(captureEventValues, thrId, entry):
    #print("StartCapture: " +  entry[entry.index(capturingEventIdFlag) + 1] + "  time:" + entry[entry.index(capturingEventTimeFlag) - 1])
    #the captureEventValues is like a running counter of all values that we follow,
    #but in-between capture events per thread, this should not be marked to correspond to any capture event (by first 2 fields),
    #because, when parsing prv events (lines) that are not related to task, we are not sure whether to capture the papi values in those or not, 
    #so we do it always, but assign (memorize them) only if we are collecting for the specific task (in processOtherEvents)
    if((thrId in captureEventValues) and (captureEventValues[thrId][0] != 0) and (captureEventValues[thrId][1] != 0)):
        print("Some miscalculation has happened and ending of previous capture event has not reset the counters. Aborting...")
        quit()
    resetCounters(captureEventValues, thrId) #still have to do this because of PAPI events in-between two capture events we are interested in
    captureEventValues[thrId][captureEventIdIndx] = entry[entry.index(capturingEventIdFlag) + 1] #this value is actually the ID we need  
    captureEventValues[thrId][captureEventTaskgraphIndx] = entry[entry.index(capturingEventTaskgraphIdFlag) + 1]#do the same for the taskgraph id  
     #we will assume that the time is always located one place before the event time flag, because that is how prv is structured 
    captureEventValues[thrId][captureEventTimeIndx] = int(entry[entry.index(capturingEventTimeFlag) - 1])

#assuming that this is correctly recognized end event
def endEventCapture(captureEventValues, thrId, entry):
    #print("endCapt time:" + entry[entry.index(capturingEventTimeFlag) - 1])
    #do nothing for captureEventValues[thrId][0]
    executionBeginTime = captureEventValues[thrId][captureEventTimeIndx]
    executionEndTime = int(entry[entry.index(capturingEventTimeFlag) - 1])
    captureEventValues[thrId][captureEventTimeIndx] = int(entry[entry.index(capturingEventTimeFlag) - 1]) - captureEventValues[thrId][captureEventTimeIndx]  #calculate execution time
    incrementCounterValuesForEventInThread(captureEventValues, thrId, entry)  #increment all PAPI event counters, so that we get final sum for this capture event
    #addition for pulling out additional values, like thread and beginning and end of execution time:
    finishedCapture = captureEventValues[thrId]  #finishedCapture first introduced here
    #adding: thread id, beginning time of execution and ending time
    finishedCapture.extend([thrId, executionBeginTime, executionEndTime])
    allCapturesCollection.append(finishedCapture)
    resetCounters(captureEventValues, thrId) #finished mapping counters on this thread in this timeframe to this capture event

#we need to add up all PAPI counters during the execution time of an event
def processOtherEvents(captureEventValues, thrId, entry):
    incrementCounterValuesForEventInThread(captureEventValues, thrId, entry)


entry = []
for l in lines:
    entry = l.strip().split(':')
    thrId = int(entry[4])
    initCountersIfNeeded(captureEventValues, thrId)
    if(isCaptureEventStart(entry)):
        startEventCapture(captureEventValues, thrId, entry)
    elif(isCaptureEventEnd(entry)):
         endEventCapture(captureEventValues, thrId, entry)
    else:
        processOtherEvents(captureEventValues, thrId, entry)

##############################################################################################        
#parsing the tdg structure: List of tdgs
# tdg: taskgraph id, list of nodes

tdgsList = []
end_to_end_deadline = -1
#Sort tdgFiles so .json are read first and we can add new executions to them
tdgFiles = sorted(tdgFiles, key = lambda x: ".json" not in x)

for tdgFile in tdgFiles:

    nodes = OrderedDict()

    if(tdgFile.endswith(".json")):
        with open(tdgFile) as tdgInput:
            content = json.load(tdgInput, object_pairs_hook=OrderedDict)
            for newTdg in content[appName]:
                tdgsList.append(newTdg)
            if "end_to_end_deadline" in content:
                end_to_end_deadline = content["end_to_end_deadline"]
            InputJsonFilePath = tdgFile
            shouldOverwriteInputJsonFile = True #since input is json, just add new results onto it

    if(tdgFile.endswith(".dot")):
        lines = []
        with open(tdgFile) as tdgInput:
            lines = tdgInput.readlines()   
        #parse the .dot file in one go and capture all the nodes and then all the dependencies
        startLineOfTdgNodes = -1
        endLineOfTdgNodes = -1
        endLineOfTdgDependencies = -1
        iterator = 0
        tdg_nodes = []
        deps = []
        input_deps = []
        output_deps = []
        taskgraph_id = int(lines[3].split('_')[1])  # Line 4 of dot file will always contain the taskgraph_id label
        while(iterator < len(lines)):
            if(("subgraph cluster" in lines[iterator]) and ("{" in lines[iterator])):
                startLineOfTdgNodes = iterator+2 #iterator+1 will be label=TDG_0, and iterator+2 is the 1st node
                iterator += 1
                continue
            if("}" in lines[iterator]):
                endLineOfTdgNodes = iterator
            if((iterator >= startLineOfTdgNodes) and (startLineOfTdgNodes != -1) and (endLineOfTdgNodes == -1)):
                tdgNodeId = lines[iterator][0 : lines[iterator].find("[", 0)].strip()
                tdg_nodes.append(tdgNodeId)   
                if(tdgNodeId in nodes):
                    print("Warning: this node should not yet be in the tdg")
                else:
                    nodes[tdgNodeId] = OrderedDict([("ins",[]), ("outs",[]), ("results",[]) ])
            if(startLineOfTdgNodes != -1 and endLineOfTdgNodes != -1): #the first subgraph already parsed
                if(("node" in lines[iterator]) or ("subgraph cluster" in lines[iterator])):
                    endLineOfTdgDependencies = iterator
                if(endLineOfTdgDependencies == -1): #not expecting dependencies after end of that region
                    if("->" in lines[iterator]):
                        words = lines[iterator].split()
                        input_deps.append( words[0])
                        output_deps.append(words[2]) #the word[1] is "->"
                        deps.append(lines[iterator])
                        currentIn = words[0]
                        currentOut = words[2]
                        if(currentIn not in nodes):
                            print("This should not happen, dependency found for non existing node")
                            quit()
                        nodes[currentIn]["outs"].append(currentOut)
                        nodes[currentOut]["ins"].append(currentIn)
            iterator += 1
        #done parsing
        if(startLineOfTdgNodes == endLineOfTdgNodes):
            print("Tdg nodes not read correctly from the .dot file. aborting")
            quit()

        #Check if tdg has already been inserted by json file
        if not any(map(lambda insTdg: insTdg['taskgraph_id'] == taskgraph_id, tdgsList)):
            tdg = OrderedDict([('taskgraph_id', taskgraph_id), ('nodes', nodes)])
        
            tdgsList.append(tdg)

#########################################################################################################################################       
#now we have the TDGs structures contained in the TDGs dictonaries, so we can fill it with already gathered Extrae's data:
#captureEventValues[thrId][captureEventTaskGraphIndx]
continueWriting = "y"
warnForDuplicatedResults = True
for tdg in tdgsList:
    current_taskgraph = tdg['taskgraph_id']
    for tdgNodeId in tdg['nodes']:
        nodeFoundInExecution = False
        
        for capture in allCapturesCollection:
            if(capture[captureEventIdIndx].strip() == str(tdgNodeId)):
                #Capture just the tasks corresponding to the taskgraph currently open
                if str(current_taskgraph) == capture[captureEventTaskgraphIndx]:
                    currentResultsDict = OrderedDict()
                    #update concatenates two ordered dicts   
                    #addition for thread id,begin and end execution time:
                    currentResultsDict.update(zip(additionalInfoFlags, capture[-3:])) #additional info, like thread id, begin and end time of execution
                    currentResultsDict.update({"execution_total_time" : capture[captureEventTimeIndx]})            
                    currentResultsDict.update(zip(papiEventFlags, capture[3:-3])) #papi counters
                    for existingResultDict in tdg['nodes'][tdgNodeId]["results"]:
                        if(warnForDuplicatedResults and (existingResultDict == currentResultsDict)):
                            print("Warning: identical execution record being added again! Check that the same .prv is not used for multiple executions of the script on the same results file!")
                            if(sys.version_info[0] <= 2):
                                continueWriting = raw_input("Do you want to continue with the writing or abort? 'y' to continue, 'n' to abort, 'a' continue and don't ask again: ")
                            else:
                                continueWriting = input("Do you want to continue with the writing or abort? 'y' to continue, 'n' to abort, 'a' continue and don't ask again: ")
                            if(continueWriting.lower() == 'n'):
                                quit()
                            elif(continueWriting.lower() == 'a'):
                                warnForDuplicatedResults = False

                    tdg['nodes'][tdgNodeId]["results"].append(currentResultsDict)

                    nodeFoundInExecution = True
        
        if(not nodeFoundInExecution):
            print("Warning: no execution is found for the node " + tdgNodeId + " in the tdg! \n This most likely means an error in either the TDG structure or in the execution, so proceed with caution!")

########################################################################################################################################        
#print the output        
if(shouldOverwriteInputJsonFile):
    with open(InputJsonFilePath, "w") as tdgOutput:
        tdgOutput.write(json.dumps({appName: tdgsList, "end_to_end_deadline": end_to_end_deadline}, indent=4))
    print("\n Updated file: " + InputJsonFilePath + "\n")
else:
    outputFileName = appName + "_output.json"
    outputFile = open(outputFileName, "w")
    outputFile.write(json.dumps({appName: tdgsList, "end_to_end_deadline": end_to_end_deadline}, indent=4))
    outputFile.close()
    print("\n Generated files: " + outputFileName + "\n")
